=== src/tests/integration/CMakeLists.txt ===
if (opencoarrays_aware_compiler)
  add_subdirectory(coarrayHelloWorld)
  if (NOT (DEFINED ENV{TRAVIS}))
    add_subdirectory(dist_transpose )
  endif()
  add_subdirectory(pde_solvers)
endif()
