=== debian/changelog ===
open-coarrays (1.6.0-1) unstable; urgency=medium
 
  * Initial release. (Closes: #826015).
    Resubmitted with additional license Information, Jun 17

 -- Alastair McKinstry <mckinstry@debian.org>  Fri, 17 Jun 2016 12:15:07 +0100
