=== debian/control ===
Source: open-coarrays
Section: utils
Priority: optional
Maintainer: Alastair McKinstry <mckinstry@debian.org>
Build-Depends: debhelper (>= 9), dh-buildinfo,
 mpi-default-dev, mpi-default-bin,
 cmake (>= 3.3.1),
 gfortran (>= 6.1)
Standards-Version: 3.9.8
Homepage: https://www.opencoarrays.org/

Package: libcoarrays-dev
Section: libdevel
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}, gfortran (>= 6.1-1), mpi-default-bin,
 libcoarrays0d (= ${binary:Version})
Description: Co-Array Fortran libraries for gfortran - development files
 OpenCoArrays is an open-source software project that supports the 
 coarray Fortran (CAF) parallel programming features of the Fortran 2008 
 standard and several features proposed for Fortran 2015 in the draft 
 Technical Specification [TS 18508] "Additional Parallel Features in Fortran".
 .
 This package provides the libraries necessary for gfortran to build parallel
 CAF programs built on top of MPI.

Package: libcoarrays0d
Section: libs
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Co-Array Fortran libraries for gfortran
 OpenCoArrays is an open-source software project that supports the
 coarray Fortran (CAF) parallel programming features of the Fortran 2008
 standard and several features proposed for Fortran 2015 in the draft
 Technical Specification [TS 18508] "Additional Parallel Features in Fortran".
 .
 This package provides the libraries necessary for gfortran to build parallel
 CAF programs built on top of MPI.

Package: open-coarrays-bin
Depends: ${misc:Depends}, libcoarrays0d (= ${binary:Version})
Recommends: libcoarrays-dev
Architecture: any
Description: Executables for running Co-Array Fortran programs
 OpenCoArrays is an open-source software project that supports the
 coarray Fortran (CAF) parallel programming features of the Fortran 2008
 standard and several features proposed for Fortran 2015 in the draft
 Technical Specification [TS 18508] "Additional Parallel Features in Fortran".
 .
 This package provides utility executables for running CAF programs.
