=== src/mpi/CMakeLists.txt ===
--- 
+++ 
@@ -53,6 +53,11 @@
 else()
   file(APPEND "${compiler_wrapper}"  "caf_compiler=false\n")
 endif()
+
+if ( DEFINED ENV{FC} )
+  file(APPEND "${compiler_wrapper}"  "CAFC=$ENV{FC}\n")
+endif ()
+
 if ("${CMAKE_SYSTEM_NAME}" MATCHES "Linux")
   file(APPEND "${compiler_wrapper}"  "linux=true\n")
 endif()
