=== src/tests/integration/coarrayHelloWorld/CMakeLists.txt ===
add_executable(hello_multiverse hello_multiverse.F90)
target_link_libraries(hello_multiverse OpenCoarrays)
