=== debian/changelog ===
open-coarrays (1.7.4-4) unstable; urgency=medium

  * B-D on openssh-client, as needed to run tests locally?
  
 -- Alastair McKinstry <mckinstry@debian.org>  Sat, 03 Dec 2016 19:21:43 +0000

open-coarrays (1.7.4-3) unstable; urgency=medium

  * Remove multi-arch: same from -dev; .mod files differ
  * Use "--oversubcribe" not "--oversubscribe" for mpiexec. Closes: #846681
  * Disable failure on tests for the moment

 -- Alastair McKinstry <mckinstry@debian.org>  Sat, 26 Nov 2016 11:23:14 +0000

open-coarrays (1.7.4-2) unstable; urgency=medium

  * Invert incorrect make check to enable tests
  * Move to unstable

 -- Alastair McKinstry <mckinstry@debian.org>  Tue, 15 Nov 2016 11:22:35 +0000

open-coarrays (1.7.4-1) experimental; urgency=medium

  * New upstream release
  * Re-enable tests for alpha, powerpc
  * Multi-Arch enable

 -- Alastair McKinstry <mckinstry@debian.org>  Fri, 04 Nov 2016 01:39:33 +0000

open-coarrays (1.7.0-2) unstable; urgency=medium

  * Set debhelper dependency to >= 10.
  * Don't link against static lib in navier_stokes test, breaks -fPIE,
    bindow. Closes: #835148
  * disable alpha, powerpc tests again. Still buggy.

 -- Alastair McKinstry <mckinstry@debian.org>  Wed, 14 Sep 2016 16:04:04 +0100

open-coarrays (1.7.0-1) experimental; urgency=medium

  * New upstream release
   - re-enabled tests on alpha, powerpc
  * DH_COMPAT=10

 -- Alastair McKinstry <mckinstry@debian.org>  Mon, 05 Sep 2016 08:27:24 +0100

open-coarrays (1.6.2-2) unstable; urgency=medium

  * Disable tests on powerpc, alpha while regression invesigated,
    to allow openmpi2 transition to proceed.

 -- Alastair McKinstry <mckinstry@debian.org>  Tue, 09 Aug 2016 12:04:19 +0100

open-coarrays (1.6.2-1) unstable; urgency=medium

  * New upstream release

 -- Alastair McKinstry <mckinstry@debian.org>  Tue, 26 Jul 2016 15:28:27 +0100
