=== debian/control ===
--- 
+++ 
@@ -2,9 +2,9 @@
 Section: utils
 Priority: optional
 Maintainer: Alastair McKinstry <mckinstry@debian.org>
-Build-Depends: debhelper (>= 9), dh-buildinfo,
+Build-Depends: debhelper (>= 10), dh-buildinfo,
  mpi-default-dev, mpi-default-bin,
- cmake (>= 3.3.1),
+ cmake (>= 3.3.1), openssh-client,
  gfortran (>= 6.1)
 Standards-Version: 3.9.8
 Homepage: https://www.opencoarrays.org/
@@ -26,6 +26,7 @@
 Package: libcoarrays0d
 Section: libs
 Architecture: any
+Multi-Arch: same
 Depends: ${misc:Depends}, ${shlibs:Depends}
 Description: Co-Array Fortran libraries for gfortran
  OpenCoArrays is an open-source software project that supports the
@@ -40,6 +41,7 @@
 Depends: ${misc:Depends}, libcoarrays0d (= ${binary:Version})
 Recommends: libcoarrays-dev
 Architecture: any
+Multi-Arch: same
 Description: Executables for running Co-Array Fortran programs
  OpenCoArrays is an open-source software project that supports the
  coarray Fortran (CAF) parallel programming features of the Fortran 2008
