=== debian/rules ===
#!/usr/bin/make -f

export DH_VERBOSE=1

DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
LIBDIR:=/usr/lib/$(DEB_HOST_MULTIARCH)

# The magic debhelper  rule
%:
	dh $@ --buildsystem=cmake

DEB_HOST_ARCH ?= $(shell dpkg-architecture -qDEB_HOST_ARCH)
# DISABLED_TESTS:= "powerpc alpha"

override_dh_auto_configure:
	        CC=mpicc FC=mpifort dh_auto_configure

override_dh_auto_install:
	dh_auto_install
	mkdir -p debian/tmp/$(LIBDIR)
	cp debian/tmp/usr/lib/libcaf* debian/tmp/$(LIBDIR)
	cp -a debian/tmp/usr/lib/cmake debian/tmp/$(LIBDIR)/cmake
	dh_link -p libcoarrays-dev $(LIBDIR)/libcaf_single.so.0d $(LIBDIR)/libcaf_single.so
	dh_link -p libcoarrays-dev $(LIBDIR)/libcaf_mpi.so.0d $(LIBDIR)/libcaf_mpi.so

override_dh_auto_test:
ifneq (,$(findstring  "$(DEB_HOST_ARCH)",$(DISABLED_TESTS)))
	@echo "Tests disabled on this arch: known failures being investigated"
else
	-dh_auto_test
endif
